// History:
//   Oprava parametrů obrázku v hlavičce, oprava odkazu na stránku údržby
//   Doplněna detekce jazyka dokumentu (ve značce body)
//   Předěláno na jinou strukturu adresářů, doplněno poukování odkazů
//   Oprava regulárního výrazu tak, aby nekazil odkaz Nahoru v patičce
//   Změna kódování na UTF-8
//   Doplněno automatické generování obsahu
//   Doplněno generování značky <a id="_Up"> pro odkaz Up v patičce
//   Doplněn skript pro sledování návštěvnosti stránek
//   Korekce zobrazení data modifikace stránky pro český jazyk
//   Doplněn do patičky odkaz na HTML validator + změna na přímý odkaz
//   Zrušeno Forum a zavedeno FAQ

var RelPath="";     // Proměnná pro uložení relativní cesty k rootu webu
                    // Všechny cesty v tomto skriptu pak mají být cestami od
                    // rootu webu (například Web/PIC/MLAB.ico)

function Test()
// Testovací funkce pro ladění
{
  with (document)
  {
    var Info;
    // Test
    // Užitečné: document.URL (cesta a jméno souboru stránky)
    write('<p class="MenuText Small">');
    write('document language '+DocLang());
    write('</p>');
    write('<p class="MenuText Small">');
    write('document language '+navigator.appVersion);
    write('</p>');
    write('<p class="MenuText Small">');
    write('document language '+document.body.lang);
    write('</p>');
    write('<p class="MenuText Small">');
    write('navigator language '+navigator.language);  // FF ano, IE6 ne
    write('</p>');
  }
}


function DocLang()
// Vrací zkratku jazyka stránky ( cs en )
// Není-li v dokumentu uvedená vrací en
{
  var s;
  s=document.body.lang.toLowerCase();
  if(s=="cs") return "cs";  // To by mě zajímalo proč je čeština cs a ne cz
  if(s=="sk") return "cs";  // Pro slováky bude asi čeština vhodnější
  return "en";              // Pro všechny ostatní dáme angličtinu
}


function SetRelativePath(Path)
// Nastaví relativní část cesty tak, abychom se dostali k rootu webu
// Například pro stránky v adresáři "Web" je tento parametr "../"
{
  // Zapamatuji si relativní cestu
  RelPath=Path;
  // Případně doplním na konec lomítko
  if (RelPath.length!=0)
    if (RelPath.charAt(RelPath.length-1)!='/')
      RelPath+='/';
}


function PokeRelativePath(Content)
// Vezme řetězec a doplní v něm všechny odkazy o relativní část cesty
{
  Content=(Content.replace(/(\s+href=[\"\'])([^#])/ig,'$1'+RelPath+'$2'));
  Content=(Content.replace(/(\s+src=[\"\'])([^#])/ig,'$1'+RelPath+'$2'));
  return Content;
}


function DrawHeader(MoreInfo)
// Nepovinny parametr udava nadpis stranky
// Neni-li uveden bere se text ze znacky title dokumentu
{
  // Proměnná pro vznikající vkládaný obsah
  var Content="";
  // Default informace pokud je parametr nezadany
  if(MoreInfo==undefined) MoreInfo=document.title;
  // Vlozeni HTML kodu
  Content+='<div class="InnerHeader"> ';
  if (DocLang()=="cs")
    { // český text
      Content+='<a href="index.cs.html" title="Domů"><span class="HeaderLogo">MLAB</span><img src="Web/PIC/MLAB_online.gif" alt="MLAB Logo"></a>';
    }
  else
    { // English text
      Content+='<a href="index.en.html" title="Home"><span class="HeaderLogo">MLAB</span><img src="Web/PIC/MLAB_online.gif" alt="MLAB Logo"></a>';
    }
  Content+='<span class="HeaderText">'+MoreInfo+'</span>';
  Content+='</div> ';
  // Korekce cest v odkazech
  Content=PokeRelativePath(Content);
  // Výstup sestaveného textu
  document.write(Content);
}


function DrawMenu(MoreInfo)
// Nepovinny parametr udava nazev menu
// Neni-li uveden dava se text Menu
//// Zvýrazněný text má navíc class="Selected", zatím se nepoužívá
{
  // Proměnná pro vznikající vkládaný obsah
  var Content="";
  // Default text
  if(MoreInfo==undefined) MoreInfo="Menu";
  // Vlastni menu
  Content+='<div class="InnerMenu">';
  Content+='  <div class="Navigation">';
  Content+='    <div class="MenuText">';
  Content+=       MoreInfo;
  Content+='    </div>';
  if (DocLang()=="cs")
    { // český text
      // POZOR: Při změně nutno zkontrolovat soubor index.cs.html
      Content+='<ul>';
      Content+='  <li> <a href="index.cs.html" title="Domů">Home</a> </li>';
      Content+='  <li> <a href="Web/Articles.cs.html" title="Články, informace">Články</a> </li>';
      Content+='  <li> <a href="Web/Modules.cs.html" title="Jednotlivé moduly MLAB">Moduly</a> </li>';
      Content+='  <li> <a href="Web/Designs.cs.html" title="Samostatné konstrukce">Konstrukce</a> </li>';
      Content+='  <li> <a href="Web/Cooperation.cs.html" title="Spolupráce">Spolupráce</a> </li>';
      Content+='  <li> <a href="Web/FAQ.cs.html" title="Nejčastější dotazy">FAQ</a> </li>';
      Content+='  <li> <a href="Web/Downloads.cs.html" title="Ke stažení">Downloads</a> </li>';
      Content+='  <li> <a href=  "http://www.mlab.cz/WebSVN/listing.php?repname=MLAB&amp;path=%2F&amp;sc=0&amp;langchoice=Česky" title="Webový přístup do databáze SVN">WebSVN</a> </li>';
      Content+='  <li> <a href=  "http://wiki.mlab.cz" title="Stránka Wiki">Wiki</a> </li>';
      Content+='  <li> <a href="Web/About.cs.html" title="O webu, stavebnici MLAB atd.">O projektu</a> </li>';
      Content+='</ul>';
    }
  else
    { // English text
      // POZOR: Při změně nutno zkontrolovat soubor index.en.html
      Content+='<ul>';
      Content+='  <li> <a href="index.en.html" title="Home">Home</a> </li>';
      Content+='  <li> <a href="Web/Articles.en.html" title="Articles and other Texts">Articles</a></i>';
      Content+='  <li> <a href="Web/Modules.en.html" title="Individual MLAB Modules">Modules</a> </li>';
      Content+='  <li> <a href="Web/Designs.en.html" title="Independed Designs">Designs</a> </li>';
      Content+='  <li> <a href="Web/Cooperation.en.html" title="Development">Cooperation</a> </li>';
      Content+='  <li> <a href="Web/FAQ.en.html" title="Frequently Asked Questions">FAQ</a> </li>';
      Content+='  <li> <a href="Web/Downloads.en.html" title="For download">Downloads</a> </li>';
      Content+='  <li> <a href=  "http://www.mlab.cz/WebSVN/listing.php?repname=MLAB&amp;path=%2F&amp;sc=0&amp;langchoice=English" title="Web interface to SVN database">WebSVN</a> </li>';
      Content+='  <li> <a href=  "http://wiki.mlab.cz" title="Wiki web">Wiki</a> </li>';
      Content+='  <li> <a href="Web/About.en.html" title="About Project">About</a> </li>';
      Content+='</ul>';
    }
  Content+='  </div>';
  Content+='</div> ';
  // Korekce cest v odkazech
  Content=PokeRelativePath(Content);
  // Výstup sestaveného textu
  document.write(Content);
}


function DrawFooter(MoreInfo)
// Nepovinny parametr pro text do paticky
{
  // Proměnná pro vznikající vkládaný obsah
  var Content="";
  var Time="";
  // Default text je prazdny
  if(MoreInfo==undefined) MoreInfo="";
  // Vlozeni HTML kodu
  Content+='<div class="InnerFooter">';
  Content+='&nbsp;';   // ústupek IE6 (chyba výpočtu šířky při nenulovém paddingu )
  if (DocLang()=="cs")
    { // český text
      Content+='<a href="#_Up" class="NoPrint">Nahoru</a> &nbsp; ';
      Content+='<a href="Web/Copyright.cs.html">Copyright</a> &copy; ';
      Content+='<a href="Web/AboutAuthors.cs.html">Autoři MLAB</a> &nbsp; ';
      Content+='<a href="Web/Maintenance.cs.html">Údržba</a> &nbsp; ';
    }
  else
    { // English text
      Content+='<a href="#_Up" class="NoPrint">Up</a> &nbsp; ';
      Content+='<a href="Web/Copyright.en.html">Copyright</a> &copy; ';
      Content+='<a href="Web/AboutAuthors.en.html">MLAB Authors</a> &nbsp; ';
      Content+='<a href="Web/Maintenance.en.html">Maintenance</a> &nbsp; ';
    }
  if (document.location.hostname!='')
    {
      Content+='<a href=  "http://validator.w3.org/check?uri='
        +document.location.href
        +'">HTML Validator</a> &nbsp; ';
    }

  Time=document.lastModified;
  if (DocLang()=="cs")
    { // Převeď anglické datum na české
      Time=(Time.replace(/(.+)\/(.+)\/(.+)/i,'$2.$1.$3'));
    }
  Content+='['+Time+'] &nbsp;&nbsp;&nbsp;';
  Content+=MoreInfo;
  Content+='</div>';
  // Korekce cest v odkazech
  Content=PokeRelativePath(Content);
  // Výstup sestaveného textu
  document.write(Content);

}


// Vlozeni cesty u vypisu adresaru
function DrawDirectory()
{
  document.write(decodeURI(location.pathname));
}


//=============================================
// Automatické generování obsahu
//
// Ke každé značce s class="PutTocHere x" vygeneruje obsah
// s hloubkou x nadpisů (defaultně 2 úrovně)


function tocGetText(obj)
// Vrať řetězec s obsahem elementu
{
  var str=""
    for (var i=0;i < obj.childNodes.length;i++)
    {
      if (obj.childNodes[i].nodeType==1)          // ELEMENT_NODE
        str += tocGetText(obj.childNodes[i])
      else if (obj.childNodes[i].nodeType==3)     // TEXT_NODE
        str += obj.childNodes[i].data
    }
  return str
}

var tocGlobalContext=0  // pro unikátní kotvy ve značce <a>

function tocHeaders(el,obj,depth)
// Proleze hierarchickou strukturu a najde vsechny nadpisy
// do zadané úrovně včetně.
{
  var tagList = "H1;H2;H3;H4;H5;H6;H7;"
  if (tagList.indexOf(obj.tagName+";")>=0)        // je to nadpis
  if (obj.tagName.charAt(1)<=depth)               // úroveň nadpisu
  {
    // Vytvoř položku seznamu
    var eLI = document.createElement("li")        // položka seznamu
    var eA  = document.createElement("a")         // uvnitř link
    var eLIText = document.createTextNode(tocGetText(obj))  // uvnitř text
    eLI.className="Toc" + obj.tagName             // úroveň nadpisu do class
    eA.href="#_Toc_"+tocGlobalContext             // cíl odkazu
    eA.appendChild(eLIText)                       // vlož text do odkazu
    eLI.appendChild(eA)                           // vlož odkaz do položky seznamu
    el.appendChild(eLI)                           // vlož položku seznamu do seznamu

    // Přidej k nadpisu kotvu (znackou <a>)
    var anchor=document.createElement("a")
    anchor.id="_Toc_"+tocGlobalContext++          // unikátní jména kotev
    obj.appendChild(anchor)                       // přidej kotvu k nadpisu
  }
  for (var i=0;i < obj.childNodes.length;i++)     // rekurze
    if (obj.childNodes[i].nodeType==1)
      tocHeaders(el,obj.childNodes[i],depth)
}


function tocPutToc(objToc)
// Rekurzivně projdi strom dokumentu a na všechna místa kam patří
// vlož seznam. Místo je ozačeno značkou s id="PutTocHere".
// Volitelně může být uveden parametr Class="x", kde x udává hloubku
// zpracovávaných nadpisů.
{
  var cl=objToc.className.split(" ")              // vezmi class a rozděl ho na slova
  if (cl[0].toUpperCase()=="PutTocHere".toUpperCase())
  {
    var depth=2                                   // default hodnota hloubky
    for (var i=1;i<cl.length;i++)
    {
      if (cl[i]!="")                              // preskoč prázdné položky (IE6)
      {
        depth=cl[i]                               // byla zadána i druhá hodnota
        break
      }
    }

    var toc = document.createElement("ul")        // Toc je nečíslovaný seznam
    toc.className="Toc"                           // s Class="Toc"

    var objHx = document.getElementsByTagName("body")[0]    // Odtud začínáme
    tocHeaders(toc,objHx,depth)                   // projdi všechny nadpisy
    objToc.appendChild(toc)                       // přidej Toc jako jeho dítě
  }
  // Rekurzivní procházení dětí
  for (var i=0;i < objToc.childNodes.length;i++)
    if (objToc.childNodes[i].nodeType==1)         // ELEMENT_NODE
      (tocPutToc(objToc.childNodes[i]))
}


function putUp()
// Funkce najde první div class="Text" a umístí do něj kotvu
// Slouží pro klikací odkaz v patičce pro skok na začátek stránky
{
  var objDiv = document.getElementsByTagName("body")[0]     // první body
  var objDiv=objDiv.getElementsByTagName("div")             // v něm všechny div
  for (var i=0;i < objDiv.length; i++)                      // celé projdi
  {
    // Test zda je to div.class="Text"
    if((" "+objDiv[i].className+" ").toUpperCase().indexOf(" TEXT ")>=0)
    {
      // Vyrob nový element kotvy (značka <a name="Up">)
      var eA=document.createElement("a")
      //eA.name="Up"                                        // nefunguje v IE
      eA.id="_Up"                                            // unikátní Id kotvy
      // Kontrolní výpis
      //var ePText=document.createTextNode("Anchor " + String(i) + " " + objDiv[i].className)
      //eA.appendChild(ePText)
      // Vlož nový element na začátek
      if (objDiv[i].childNodes.length>0)
        objDiv[i].insertBefore(eA,objDiv[i].childNodes[0])  // před první dítě
      else
        objDiv[i].appendChild(eA)                           // žádné dítě nebylo
      // Hotovo
      break
    }
    // Kontrolní výpis
    //var eP=document.createElement("p")
    //var ePText=document.createTextNode("Div " + String(i) + " " + objDiv[i].className)
    //eP.appendChild(ePText)
    //objDiv[0].appendChild(eP)
  }
}

// Zaregistruj výkonný skript po načtení celé stránky
window.onload = doLoad
